/**
 * ModifyDNRequest.java
 *
 * File generated from the core::ModifyDNRequest uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.hpd;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class ModifyDNRequest.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ModifyDNRequest", propOrder = {
		"deleteoldrdn",
		"dn",
		"newrdn",
		"newSuperior"
})
@XmlRootElement(name = "ModifyDNRequest")
public class ModifyDNRequest extends net.ihe.gazelle.hpd.DsmlMessage implements java.io.Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;


	@XmlAttribute(name = "deleteoldrdn")
	public Boolean deleteoldrdn;
	@XmlAttribute(name = "dn", required = true)
	public java.lang.String dn;
	@XmlAttribute(name = "newrdn", required = true)
	public java.lang.String newrdn;
	@XmlAttribute(name = "newSuperior")
	public java.lang.String newSuperior;

	public ModifyDNRequest(){
		super();
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;


	/**
	 * Return deleteoldrdn.
	 * @return deleteoldrdn
	 */
	public Boolean getDeleteoldrdn() {
		return deleteoldrdn;
	}

	/**
	 * Set a value to attribute deleteoldrdn.
	 * @param deleteoldrdn.
	 */
	public void setDeleteoldrdn(Boolean deleteoldrdn) {
		this.deleteoldrdn = deleteoldrdn;
	}


	/**
	 * Return deleteoldrdn.
	 * @return deleteoldrdn
	 * Generated for the use on jsf pages
	 */
	@Deprecated
	public Boolean isDeleteoldrdn() {
		return deleteoldrdn;
	}

	/**
	 * Return dn.
	 * @return dn
	 */
	public java.lang.String getDn() {
		return dn;
	}

	/**
	 * Set a value to attribute dn.
	 * @param dn.
	 */
	public void setDn(java.lang.String dn) {
		this.dn = dn;
	}




	/**
	 * Return newrdn.
	 * @return newrdn
	 */
	public java.lang.String getNewrdn() {
		return newrdn;
	}

	/**
	 * Set a value to attribute newrdn.
	 * @param newrdn.
	 */
	public void setNewrdn(java.lang.String newrdn) {
		this.newrdn = newrdn;
	}




	/**
	 * Return newSuperior.
	 * @return newSuperior
	 */
	public java.lang.String getNewSuperior() {
		return newSuperior;
	}

	/**
	 * Set a value to attribute newSuperior.
	 * @param newSuperior.
	 */
	public void setNewSuperior(java.lang.String newSuperior) {
		if (newSuperior != null && newSuperior.isEmpty()){
			this.newSuperior = null;
		}else{
			this.newSuperior = newSuperior;
		}
	}





	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
			JAXBContext jc;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			DocumentBuilder db = null;
			Document doc = null;
			try {
				db = dbf.newDocumentBuilder();
				doc = db.newDocument();
			} catch (ParserConfigurationException e1) {}
			try {
				jc = JAXBContext.newInstance("net.ihe.gazelle.hpd");
				Marshaller m = jc.createMarshaller();
				m.marshal(this, doc);
				_xmlNodePresentation = doc.getElementsByTagNameNS("urn:oasis:names:tc:DSML:2:0:core", "ModifyDNRequest").item(0);
			} catch (JAXBException e) {
				try{
					db = dbf.newDocumentBuilder();
					_xmlNodePresentation = db.newDocument();
				}
				catch(Exception ee){}
			}
		}
		return _xmlNodePresentation;
	}

	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}





	/**
	 * validate by a module of validation
	 * 
	 */
	public static void validateByModule(ModifyDNRequest modifyDNRequest, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
		if (modifyDNRequest != null){
			net.ihe.gazelle.hpd.DsmlMessage.validateByModule(modifyDNRequest, _location, cvm, diagnostic);
		}
	}

}